module vend_toplevel(clk100, rst, tx, done);
 
	input clk100, rst;
	output tx;
	output [7:0] done; 
	
	
	wire [7:0] adout;
	wire control;
	wire [9:0] sel;
	wire [179:0] rooutput;
	wire counteren;
	wire [31:0] roout;
	wire [31:0] rooutp1;
	wire [179:0] roen;
	wire countrest;
	wire tx_done;
	wire tx_start;
	wire s_tick;
	wire tx_done_tick;
	wire clk;
	reg  [4:0] data_in   = 0   ;
   reg        com_start   = 1'b0;
	
	wire [4:0] arr_mem [15:0];	
	reg  [3:0] address   = 0   ;
	wire Sel0, Sel1, Sel2, Sel3, Sel4;
	wire com_startn;
	parameter CLK_FREQ = 100000000;
    reg [26:0] timer_cnt      = 1'b0;    
    reg        timer_timeout  = 1'b0;
	 reg time_start=1'b0;
	 reg [5:0] state;
	 
    // Assigning data to ram memory 
    assign  arr_mem[0]  =   5'b00001;
    assign  arr_mem[1]  =   5'b00010;
    assign  arr_mem[2]  =   5'b00100;        
    assign  arr_mem[3]  =   5'b00111;         
    assign  arr_mem[4]  =   5'b01000;        
    assign  arr_mem[5]  =   5'b01011;         
    assign  arr_mem[6]  =   5'b01101;        
    assign  arr_mem[7]  =   5'b01110;         
    assign  arr_mem[8]  =   5'b10000;         
    assign  arr_mem[9]  =   5'b10011;        
    assign  arr_mem[10] =   5'b10101;        
    assign  arr_mem[11] =   5'b10110;         
    assign  arr_mem[12] =   5'b11001;      
    assign  arr_mem[13] =   5'b11010; 
    assign  arr_mem[14] =   5'b11100;      
    assign  arr_mem[15] =   5'b11111;     
	 
		(*S="TRUE"*)wire  roout7,roout6, roout5,roout4,roout3,roout2,roout1,roout0;
		(*S="TRUE"*)wire  roout15, roout14,roout13,roout12,roout11,roout10,roout9,roout8;
		(*S="TRUE"*)wire  roout19,roout18,roout17,roout16;
		(*S="TRUE"*)wire  roout28, roout27, roout26,roout25,roout24,roout23,roout22, roout21, roout20;
		(*S="TRUE"*)wire  roout35, roout34, roout33,	roout32,	roout31,	roout30,	roout29;
		(*S="TRUE"*)wire  roout39,	roout38,	roout37,	roout36;
		(*S="TRUE"*)wire  roout49, roout48, roout47, roout46,roout45,roout44, roout43,roout42,roout41,roout40;
		(*S="TRUE"*)wire  roout59, roout58, roout57, roout56,roout55,roout54, roout53,roout52,roout51,roout50;
		(*S="TRUE"*)wire  roout69, roout68, roout67, roout66,roout65,roout64, roout63,roout62,roout61,roout60;
		(*S="TRUE"*)wire  roout79, roout78, roout77, roout76,roout75,roout74, roout73,roout72,roout71,roout70;
		(*S="TRUE"*)wire  roout89, roout88, roout87, roout86,roout85,roout84, roout83,roout82,roout81,roout80;
		(*S="TRUE"*)wire  roout99, roout98, roout97, roout96,roout95,roout94, roout93,roout92,roout91,roout90;
		(*S="TRUE"*)wire  roout107, roout106,roout105,roout104, roout103,roout102,roout101,roout100;
		(*S="TRUE"*)wire  roout108, roout109, roout110, roout111, roout112, roout113, roout114, roout115, roout116, roout117;
		(*S="TRUE"*)wire  roout118, roout119, roout120, roout121, roout122, roout123, roout124, roout125, roout126, roout127;
		(*S="TRUE"*)wire  roout128, roout129, roout130, roout131, roout132, roout133, roout134, roout135, roout136, roout137;
		(*S="TRUE"*)wire  roout138, roout139, roout140, roout141, roout142, roout143, roout144, roout145, roout146, roout147;
		(*S="TRUE"*)wire  roout148, roout149, roout150, roout151, roout152, roout153, roout154, roout155, roout156, roout157;
		(*S="TRUE"*)wire  roout158, roout159, roout160, roout161, roout162, roout163, roout164, roout165, roout166, roout167;
		(*S="TRUE"*)wire  roout168, roout169, roout170, roout171, roout172, roout173, roout174, roout175, roout176, roout177;
		(*S="TRUE"*)wire  roout178, roout179, roout180, roout181, roout182, roout183, roout184, roout185, roout186, roout187;
		(*S="TRUE"*)wire  roout188, roout189, roout190, roout191, roout192, roout193, roout194, roout195, roout196, roout197;
		(*S="TRUE"*)wire  roout198, roout199, roout200, roout201, roout202, roout203, roout204, roout205, roout206, roout207;
		(*S="TRUE"*)wire  roout208, roout209, roout210, roout211, roout212, roout213, roout214, roout215, roout216, roout217;
		(*S="TRUE"*)wire  roout218, roout219, roout220, roout221, roout222, roout223, roout224, roout225, roout226, roout227;
		(*S="TRUE"*)wire  roout228, roout229, roout230, roout231, roout232, roout233, roout234, roout235, roout236, roout237;
		(*S="TRUE"*)wire  roout238, roout239, roout240, roout241, roout242, roout243, roout244, roout245, roout246, roout247;
		(*S="TRUE"*)wire  roout248, roout249, roout250, roout251, roout252, roout253, roout254, roout255;


//		assign rooutput[255:246] = {roout255, roout254, roout253, roout252, roout251, roout250, roout249, roout248, roout247, roout246};
//		assign rooutput[245:236] = {roout245, roout244, roout243, roout242, roout241, roout240, roout239, roout238, roout237, roout236};
//		assign rooutput[235:226] = {roout235, roout234, roout233, roout232, roout231, roout230, roout229, roout228, roout227, roout226};
//		assign rooutput[225:216] = {roout225, roout224, roout223, roout222, roout221, roout220, roout219, roout218, roout217, roout216};
//		assign rooutput[215:206] = {roout215, roout214, roout213, roout212, roout211, roout210, roout209, roout208, roout207, roout206};
//		assign rooutput[205:196] = {roout205, roout204, roout203, roout202, roout201, roout200, roout199, roout198, roout197, roout196};
//		assign rooutput[195:186] = {roout195, roout194, roout193, roout192, roout191, roout190, roout189, roout188, roout187, roout186};
//		assign rooutput[185:176] = {roout185, roout184, roout183, roout182, roout181, roout180, roout179, roout178, roout177, roout176};
		assign rooutput[179:176] = {roout179, roout178, roout177, roout176};
		assign rooutput[175:166] = {roout175, roout174, roout173, roout172, roout171, roout170, roout169, roout168, roout167, roout166};
		assign rooutput[165:156] = {roout165, roout164, roout163, roout162, roout161, roout160, roout159, roout158, roout157, roout156};
		assign rooutput[155:146] = {roout155, roout154, roout153, roout152, roout151, roout150, roout149, roout148, roout147, roout146};
		assign rooutput[149:146] = {roout149, roout148, roout147, roout146};
		assign rooutput[145:136] = {roout145, roout144, roout143, roout142, roout141, roout140, roout139, roout138, roout137, roout136};
		assign rooutput[135:126] = {roout135, roout134, roout133, roout132, roout131, roout130, roout129, roout128, roout127, roout126};
		assign rooutput[127:126] = {roout127, roout126};
		assign rooutput[125:116] = {roout125, roout124, roout123, roout122, roout121, roout120, roout119, roout118, roout117, roout116};
		assign rooutput[115:106] = {roout115, roout114, roout113, roout112, roout111, roout110, roout109, roout108, roout107, roout106};
		assign rooutput[105:96] = {roout105, roout104, roout103, roout102, roout101, roout100, roout99, roout98, roout97, roout96};
		assign rooutput[95:86] = {roout95, roout94, roout93, roout92, roout91, roout90, roout89, roout88, roout87, roout86};
		assign rooutput[85:76] = {roout85, roout84, roout83, roout82, roout81, roout80, roout79, roout78, roout77, roout76};
		assign rooutput[75:66] = {roout75, roout74, roout73, roout72, roout71, roout70, roout69, roout68, roout67, roout66};
		assign rooutput[65:56] = {roout65, roout64, roout63, roout62, roout61, roout60, roout59, roout58, roout57, roout56};
		assign rooutput[55:46] = {roout55, roout54, roout53, roout52, roout51, roout50, roout49, roout48, roout47, roout46};
		assign rooutput[45:36] = {roout45, roout44, roout43, roout42, roout41, roout40, roout39, roout38, roout37, roout36};
		assign rooutput[35:26] = {roout35, roout34, roout33, roout32, roout31, roout30, roout29, roout28, roout27, roout26};
		assign rooutput[25:16] = {roout25, roout24, roout23, roout22, roout21, roout20, roout19, roout18, roout17, roout16};
		assign rooutput[15:6] = {roout15, roout14, roout13, roout12, roout11, roout10, roout9, roout8, roout7, roout6};
		assign rooutput[5:0] = {roout5, roout4, roout3, roout2, roout1, roout0};

// Combinations
    // writing data to uart and incrementing address for memory
	 assign Sel0=data_in[0];
	 assign Sel1=data_in[1];
	 assign Sel2=data_in[2];
	 assign Sel3=data_in[3];
	 assign Sel4=data_in[4];
	 assign com_startn = com_start; 


/*always@(state)
	case (state)
  
		9'd0: begin done <= 8'h00; roentemp=1'b0; counteren=1'b0; countrest = 1'b0; control = 1'b0; end
  
		9'd1: begin done <= 8'h02; roentemp=1'b0; counteren=1'b0; countrest = 1'b1; control = 1'b0; end
		9'd2: begin done <= 8'h02; roentemp=1'b1; counteren=1'b0; countrest = 1'b1; control = 1'b0; end
		9'd3: begin done <= 8'h02; roentemp=1'b1; counteren=1'b1; countrest = 1'b0; control = 1'b0; end
		9'd4: begin done <= 8'h02; roentemp=1'b0; counteren=1'b0; countrest = 1'b0; control = 1'b1; end  
		9'd5: begin done <= 8'h02; roentemp=1'b0; counteren=1'b0; countrest = 1'b0; control = 1'b0; end
		9'd6: begin done <= 8'h02; end
		9'd7: begin done <= 8'hF0; end
		
		default: begin done <= 8'h00; roentemp=1'b0; counteren=1'b0; countrest = 1'b0; control = 1'b0; end
		
	endcase
*/
  
  always @(posedge clk)
  begin: COM_FSM
	if (rst) begin 
		state <= 5'd0;  data_in<=  arr_mem[0];  address<=  4'd0;
	end else  
		case(state)
			
			5'd0: begin if(done[7] && ~done[0]) state <= state + 1'b1; end //&& address < 4'd16
			5'd1: begin data_in<=  arr_mem[address]; state <= state + 1'b1; end
			5'd2: begin state <= state + 1'b1; end
			5'd3: begin state <= state + 1'b1; end
			5'd4: begin state <= state + 1'b1;  com_start<=  1'b1; end 
			5'd5: begin state <= state + 1'b1;  end
			5'd6: begin com_start<=  1'b0; state <= state + 1'b1; end
			
			5'd7: begin if(address == 4'd15) begin state <= 5'd8;end
			else begin address <= address + 1'b1; state <= 5'd0; end end
			
			5'd8: begin if(rst) state <= 5'd0; end
			
			default: begin state<=5'd8; end
		endcase
	end 
	 
	 

// Clock		
		clk_div clk_div4to1(.clk(clk100),.reset(rst),.clk_out(clk));
// ROs
ro15stages_M_XOR ro1(.en(roen[0]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout0));
ro15stages_M_XOR ro2(.en(roen[1]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout1));
ro15stages_M_XOR ro3(.en(roen[2]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout2));
ro15stages_M_XOR ro4(.en(roen[3]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout3));
ro15stages_M_XOR ro5(.en(roen[4]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout4));
ro15stages_M_XOR ro6(.en(roen[5]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout5));
ro15stages_M_XOR ro7(.en(roen[6]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout6));
ro15stages_M_XOR ro8(.en(roen[7]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout7));
ro15stages_M_XOR ro9(.en(roen[8]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout8));
ro15stages_M_XOR ro10(.en(roen[9]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout9));
ro15stages_M_XOR ro11(.en(roen[10]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout10));
ro15stages_M_XOR ro12(.en(roen[11]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout11));
ro15stages_M_XOR ro13(.en(roen[12]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout12));
ro15stages_M_XOR ro14(.en(roen[13]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout13));
ro15stages_M_XOR ro15(.en(roen[14]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout14));
ro15stages_M_XOR ro16(.en(roen[15]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout15));
ro15stages_M_XOR ro17(.en(roen[16]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout16));
ro15stages_M_XOR ro18(.en(roen[17]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout17));
ro15stages_M_XOR ro19(.en(roen[18]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout18));
ro15stages_M_XOR ro20(.en(roen[19]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout19));
ro15stages_M_XOR ro21(.en(roen[20]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout20));
ro15stages_M_XOR ro22(.en(roen[21]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout21));
ro15stages_M_XOR ro23(.en(roen[22]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout22));
ro15stages_M_XOR ro24(.en(roen[23]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout23));
ro15stages_M_XOR ro25(.en(roen[24]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout24));
ro15stages_M_XOR ro26(.en(roen[25]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout25));
ro15stages_M_XOR ro27(.en(roen[26]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout26));
ro15stages_M_XOR ro28(.en(roen[27]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout27));
ro15stages_M_XOR ro29(.en(roen[28]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout28));
ro15stages_M_XOR ro30(.en(roen[29]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout29));
ro15stages_M_XOR ro31(.en(roen[30]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout30));
ro15stages_M_XOR ro32(.en(roen[31]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout31));
ro15stages_M_XOR ro33(.en(roen[32]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout32));
ro15stages_M_XOR ro34(.en(roen[33]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout33));
ro15stages_M_XOR ro35(.en(roen[34]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout34));
ro15stages_M_XOR ro36(.en(roen[35]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout35));
ro15stages_M_XOR ro37(.en(roen[36]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout36));
ro15stages_M_XOR ro38(.en(roen[37]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout37));
ro15stages_M_XOR ro39(.en(roen[38]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout38));
ro15stages_M_XOR ro40(.en(roen[39]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout39));
ro15stages_M_XOR ro41(.en(roen[40]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout40));
ro15stages_M_XOR ro42(.en(roen[41]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout41));
ro15stages_M_XOR ro43(.en(roen[42]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout42));
ro15stages_M_XOR ro44(.en(roen[43]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout43));
ro15stages_M_XOR ro45(.en(roen[44]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout44));
ro15stages_M_XOR ro46(.en(roen[45]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout45));
ro15stages_M_XOR ro47(.en(roen[46]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout46));
ro15stages_M_XOR ro48(.en(roen[47]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout47));
ro15stages_M_XOR ro49(.en(roen[48]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout48));
ro15stages_M_XOR ro50(.en(roen[49]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout49));
ro15stages_M_XOR ro51(.en(roen[50]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout50));
ro15stages_M_XOR ro52(.en(roen[51]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout51));
ro15stages_M_XOR ro53(.en(roen[52]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout52));
ro15stages_M_XOR ro54(.en(roen[53]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout53));
ro15stages_M_XOR ro55(.en(roen[54]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout54));
ro15stages_M_XOR ro56(.en(roen[55]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout55));
ro15stages_M_XOR ro57(.en(roen[56]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout56));
ro15stages_M_XOR ro58(.en(roen[57]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout57));
ro15stages_M_XOR ro59(.en(roen[58]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout58));
ro15stages_M_XOR ro60(.en(roen[59]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout59));
ro15stages_M_XOR ro61(.en(roen[60]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout60));
ro15stages_M_XOR ro62(.en(roen[61]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout61));
ro15stages_M_XOR ro63(.en(roen[62]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout62));
ro15stages_M_XOR ro64(.en(roen[63]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout63));
ro15stages_M_XOR ro65(.en(roen[64]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout64));
ro15stages_M_XOR ro66(.en(roen[65]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout65));
ro15stages_M_XOR ro67(.en(roen[66]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout66));
ro15stages_M_XOR ro68(.en(roen[67]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout67));
ro15stages_M_XOR ro69(.en(roen[68]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout68));
ro15stages_M_XOR ro70(.en(roen[69]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout69));
ro15stages_M_XOR ro71(.en(roen[70]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout70));
ro15stages_M_XOR ro72(.en(roen[71]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout71));
ro15stages_M_XOR ro73(.en(roen[72]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout72));
ro15stages_M_XOR ro74(.en(roen[73]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout73));
ro15stages_M_XOR ro75(.en(roen[74]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout74));
ro15stages_M_XOR ro76(.en(roen[75]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout75));
ro15stages_M_XOR ro77(.en(roen[76]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout76));
ro15stages_M_XOR ro78(.en(roen[77]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout77));
ro15stages_M_XOR ro79(.en(roen[78]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout78));
ro15stages_M_XOR ro80(.en(roen[79]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout79));
ro15stages_M_XOR ro81(.en(roen[80]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout80));
ro15stages_M_XOR ro82(.en(roen[81]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout81));
ro15stages_M_XOR ro83(.en(roen[82]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout82));
ro15stages_M_XOR ro84(.en(roen[83]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout83));
ro15stages_M_XOR ro85(.en(roen[84]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout84));
ro15stages_M_XOR ro86(.en(roen[85]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout85));
ro15stages_M_XOR ro87(.en(roen[86]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout86));
ro15stages_M_XOR ro88(.en(roen[87]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout87));
ro15stages_M_XOR ro89(.en(roen[88]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout88));
ro15stages_M_XOR ro90(.en(roen[89]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout89));
ro15stages_M_XOR ro91(.en(roen[90]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout90));
ro15stages_M_XOR ro92(.en(roen[91]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout91));
ro15stages_M_XOR ro93(.en(roen[92]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout92));
ro15stages_M_XOR ro94(.en(roen[93]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout93));
ro15stages_M_XOR ro95(.en(roen[94]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout94));
ro15stages_M_XOR ro96(.en(roen[95]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout95));
ro15stages_M_XOR ro97(.en(roen[96]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout96));
ro15stages_M_XOR ro98(.en(roen[97]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout97));
ro15stages_M_XOR ro99(.en(roen[98]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout98));
ro15stages_M_XOR ro100(.en(roen[99]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout99));
ro15stages_M_XOR ro101(.en(roen[100]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout100));
ro15stages_M_XOR ro102(.en(roen[101]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout101));
ro15stages_M_XOR ro103(.en(roen[102]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout102));
ro15stages_M_XOR ro104(.en(roen[103]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout103));
ro15stages_M_XOR ro105(.en(roen[104]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout104));
ro15stages_M_XOR ro106(.en(roen[105]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout105));
ro15stages_M_XOR ro107(.en(roen[106]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout106));
ro15stages_M_XOR ro108(.en(roen[107]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout107));
ro15stages_M_XOR ro109(.en(roen[108]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout108));
ro15stages_M_XOR ro110(.en(roen[109]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout109));
ro15stages_M_XOR ro111(.en(roen[110]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout110));
ro15stages_M_XOR ro112(.en(roen[111]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout111));
ro15stages_M_XOR ro113(.en(roen[112]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout112));
ro15stages_M_XOR ro114(.en(roen[113]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout113));
ro15stages_M_XOR ro115(.en(roen[114]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout114));
ro15stages_M_XOR ro116(.en(roen[115]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout115));
ro15stages_M_XOR ro117(.en(roen[116]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout116));
ro15stages_M_XOR ro118(.en(roen[117]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout117));
ro15stages_M_XOR ro119(.en(roen[118]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout118));
ro15stages_M_XOR ro120(.en(roen[119]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout119));
ro15stages_M_XOR ro121(.en(roen[120]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout120));
ro15stages_M_XOR ro122(.en(roen[121]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout121));
ro15stages_M_XOR ro123(.en(roen[122]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout122));
ro15stages_M_XOR ro124(.en(roen[123]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout123));
ro15stages_M_XOR ro125(.en(roen[124]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout124));
ro15stages_M_XOR ro126(.en(roen[125]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout125));
ro15stages_M_XOR ro127(.en(roen[126]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout126));
ro15stages_M_XOR ro128(.en(roen[127]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout127));
ro15stages_M_XOR ro129(.en(roen[128]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout128));
ro15stages_M_XOR ro130(.en(roen[129]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout129));
ro15stages_M_XOR ro131(.en(roen[130]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout130));
ro15stages_M_XOR ro132(.en(roen[131]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout131));
ro15stages_M_XOR ro133(.en(roen[132]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout132));
ro15stages_M_XOR ro134(.en(roen[133]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout133));
ro15stages_M_XOR ro135(.en(roen[134]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout134));
ro15stages_M_XOR ro136(.en(roen[135]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout135));
ro15stages_M_XOR ro137(.en(roen[136]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout136));
ro15stages_M_XOR ro138(.en(roen[137]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout137));
ro15stages_M_XOR ro139(.en(roen[138]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout138));
ro15stages_M_XOR ro140(.en(roen[139]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout139));
ro15stages_M_XOR ro141(.en(roen[140]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout140));
ro15stages_M_XOR ro142(.en(roen[141]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout141));
ro15stages_M_XOR ro143(.en(roen[142]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout142));
ro15stages_M_XOR ro144(.en(roen[143]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout143));
ro15stages_M_XOR ro145(.en(roen[144]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout144));
ro15stages_M_XOR ro146(.en(roen[145]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout145));
ro15stages_M_XOR ro147(.en(roen[146]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout146));
ro15stages_M_XOR ro148(.en(roen[147]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout147));
ro15stages_M_XOR ro149(.en(roen[148]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout148));
ro15stages_M_XOR ro150(.en(roen[149]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout149));
ro15stages_M_XOR ro151(.en(roen[150]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout150));
ro15stages_M_XOR ro152(.en(roen[151]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout151));
ro15stages_M_XOR ro153(.en(roen[152]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout152));
ro15stages_M_XOR ro154(.en(roen[153]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout153));
ro15stages_M_XOR ro155(.en(roen[154]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout154));
ro15stages_M_XOR ro156(.en(roen[155]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout155));
ro15stages_M_XOR ro157(.en(roen[156]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout156));
ro15stages_M_XOR ro158(.en(roen[157]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout157));
ro15stages_M_XOR ro159(.en(roen[158]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout158));
ro15stages_M_XOR ro160(.en(roen[159]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout159));
ro15stages_M_XOR ro161(.en(roen[160]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout160));
ro15stages_M_XOR ro162(.en(roen[161]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout161));
ro15stages_M_XOR ro163(.en(roen[162]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout162));
ro15stages_M_XOR ro164(.en(roen[163]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout163));
ro15stages_M_XOR ro165(.en(roen[164]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout164));
ro15stages_M_XOR ro166(.en(roen[165]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout165));
ro15stages_M_XOR ro167(.en(roen[166]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout166));
ro15stages_M_XOR ro168(.en(roen[167]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout167));
ro15stages_M_XOR ro169(.en(roen[168]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout168));
ro15stages_M_XOR ro170(.en(roen[169]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout169));
ro15stages_M_XOR ro171(.en(roen[170]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout170));
ro15stages_M_XOR ro172(.en(roen[171]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout171));
ro15stages_M_XOR ro173(.en(roen[172]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout172));
ro15stages_M_XOR ro174(.en(roen[173]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout173));
ro15stages_M_XOR ro175(.en(roen[174]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout174));
ro15stages_M_XOR ro176(.en(roen[175]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout175));
ro15stages_M_XOR ro177(.en(roen[176]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout176));
ro15stages_M_XOR ro178(.en(roen[177]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout177));
ro15stages_M_XOR ro179(.en(roen[178]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout178));
ro15stages_M_XOR ro180(.en(roen[179]),.Sel0(Sel0), .Sel1(Sel1), .Sel2(Sel2), .Sel3(Sel3), .Sel4(Sel4), .roout(roout179));

		
		
		roctrl_2 rc(.clk(clk),.roen(roen),.counteren(counteren),.reset(rst), .com_startn(com_startn),.countrest(countrest),
			.sel(sel), .control(control), .tx_done(tx_done), .done(done));
	
		rosel rm(.reset(rst),.com_startn(com_startn),.counteren(counteren), .countrest(countrest), .sel(sel), .ro(rooutput),.outp(roout));
		
		UART_TX uart(.clk(clk), .reset(rst), .i_TX_DV(tx_start),.i_TX_Byte(adout),
		.o_TX_Done(tx_done_tick), .tx(tx));
		
		//mod_m_counter baud(.clk(clk), .reset(rst), .tick(s_tick));

		arduino ad(.clk(clk),.control(control),.tx_done_tick(o_TX_Done), .reset(rst) ,.roout(roout), .adout(adout), .tx_start(i_TX_DV), .tx_done(tx_done),.sel(sel));
		

endmodule
