	----------------------------------------------------------------------------------
	-- Company: 
	-- Engineer: 
	-- 
	-- Create Date:    16:05:14 05/15/2010 
	-- Design Name: 
	-- Module Name:    ro - Behavioral 
	-- Project Name: 
	-- Target Devices: 
	-- Tool versions: 
	-- Description: 
	--
	-- Dependencies: 
	--
	-- Revision: 
	-- Revision 0.01 - File Created
	-- Additional Comments: 
	--
	----------------------------------------------------------------------------------
	library IEEE;
	use IEEE.STD_LOGIC_1164.ALL;

	-- Uncomment the following library declaration if using
	-- arithmetic functions with Signed or Unsigned values
	--use IEEE.NUMERIC_STD.ALL;

	-- Uncomment the following library declaration if instantiating
	-- any Xilinx primitives in this code.
	library UNISIM;
	use UNISIM.VComponents.all;

	entity ro is
	 Port ( en 		: in  STD_LOGIC_VECTOR(4 downto 0);
			  INIT : in  STD_LOGIC;
			  roout : out  STD_LOGIC
			 );
	end ro;

	architecture Behavioral of ro is

	--	component counter32
	--		Port ( a : in  STD_LOGIC;
	--			b : out  STD_LOGIC);
	--	end component;
	--	
	--	component notgate
	--	    Port ( a : in  STD_LOGIC;
	--           b : out  STD_LOGIC);
	--	end component;

	--	component nandgate
	--	    Port ( a : in  STD_LOGIC;
	--           b : in  STD_LOGIC;
	--           c : out  STD_LOGIC);
	--	end component;

	signal tmp : std_logic_vector(15 downto 0);
	--	signal tmp1 : std_logic_vector(6 downto 0);
	signal sel  : STD_LOGIC_VECTOR(4 downto 0);

	attribute keep : boolean;
	attribute keep of tmp : signal is TRUE;
	--	attribute keep of tmp1 : signal is TRUE;
	attribute keep of sel : signal is TRUE;

	begin

	roout <= tmp(1);

	--ID_OUT: LUT1
	--generic map (
	--INIT => "10")
	--port map (
	--O => roout, -- LUT general output
	--I0 => tmp(0)-- LUT input
	--);

	--	not_1: notgate port map(tmp(0), tmp(1));
	ID_EN0: LUT1
	generic map (
	INIT => "10")
	port map (
		O => sel(0), -- LUT general output
		I0 => en(0)-- LUT input
	);
		
	ID_EN1: LUT1
	generic map (
	INIT => "10")
		port map (
		O => sel(1), -- LUT general output
		I0 => en(1)-- LUT input
		);
	--
	ID_EN2: LUT1
	generic map (
	INIT => "10")
	port map (
	O => sel(2), -- LUT general output
	I0 => en(2)-- LUT input
	);

	ID_EN3: LUT1
	generic map (
	INIT => "10")
	port map (
	O => sel(3), -- LUT general output
	I0 => en(3)-- LUT input
	);

	ID_EN4: LUT1
	generic map (
	INIT => "10")
	port map (
	O => sel(4), -- LUT general output
	I0 => en(4)-- LUT input
	);		

	--tmp(0)<='1';
	
	not_1 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(1), -- LUT general output
	I0 => tmp(0), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);

	not_2 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(2), -- LUT general output
	I0 => tmp(1), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_3 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(3), -- LUT general output
	I0 => tmp(2), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	not_4 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(4), -- LUT general output
	I0 => tmp(3), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	not_5 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(5), -- LUT general output
	I0 => tmp(4), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_6 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(6), -- LUT general output
	I0 => tmp(5), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_7 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(7), -- LUT general output
	I0 => tmp(6), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_8 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(8), -- LUT general output
	I0 => tmp(7), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_9 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(9), -- LUT general output
	I0 => tmp(8), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_10 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(10), -- LUT general output
	I0 => tmp(9), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_11 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(11), -- LUT general output
	I0 => tmp(10), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_12 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(12), -- LUT general output
	I0 => tmp(11), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_13 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(13), -- LUT general output
	I0 => tmp(12), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_14 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(14), -- LUT general output
	I0 => tmp(13), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_15 : LUT6
	generic map (
	INIT => X"6996_9669_9669_6996") -- Specify LUT Contents
	port map (
	O => tmp(15), -- LUT general output
	I0 => tmp(14), -- LUT input
	I1 => sel(0), -- LUT input
	I2 => sel(1), -- LUT input
	I3 => sel(2), -- LUT input
	I4 => sel(3), -- LUT input
	I5 => sel(4) -- LUT input
	);
	
	not_16: LUT2
		generic map (
		INIT => X"8")
		port map (
		O => tmp(0), -- LUT general output
		I0 => tmp(15),-- LUT input
		I1 => INIT
		);
	
	--not_1: LUT4
	--	generic map (
	--	INIT => X"6996")
	--	port map (
	--	O => tmp(1), -- LUT general output
	--	I0 => tmp(0),-- LUT input
	--	I1 => sel(0),-- LUT input
	--	I2 => sel(1),
	--	I3 => sel(2)
	--	);
	--	
	--nand_2: LUT4
	--	generic map (
	--	INIT => X"6996")
	--	port map (
	--	O => tmp(2), -- LUT general output
	--	I0 => tmp(1),-- LUT input
	--	I1 => sel(0),-- LUT input
	--	I2 => sel(1),
	--	I3 => sel(2)
	--	);
	--not_3: LUT4
	--	generic map (
	--	INIT => X"6996")
	--	port map (
	--	O => tmp(3), -- LUT general output
	--	I0 => tmp(2),-- LUT input
	--	I1 => sel(0),-- LUT input
	--	I2 => sel(1),
	--	I3 => sel(2)
	--	);
	--not_4: LUT4
	--	generic map (
	--	INIT => X"6996")
	--	port map (
	--	O => tmp(4), -- LUT general output
	--	I0 => tmp(3),-- LUT input
	--	I1 => sel(0),-- LUT input
	--	I2 => sel(1),
	--	I3 => sel(2)
	--	);
	--
	--not_5:  LUT4
	--	generic map (INIT => X"6996")
	--	port map (
	--	O => tmp(5), -- LUT general output
	--	I0 => tmp(4),-- LUT input
	--	I1 => sel(0),-- LUT input
	--	I2 => sel(1),
	--	I3 => sel(2)	);
	--	
	--
	--not_6:  LUT4
	--	generic map (
	--	INIT => X"6996")
	--	port map (
	--	O => tmp(6), -- LUT general output
	--	I0 => tmp(5),-- LUT input
	--	I1 => sel(0),-- LUT input
	--	I2 => sel(1),
	--	I3 => sel(2)
	--	);
	--	
	--not_7: LUT4
	--	generic map (
	--	INIT => X"6996")
	--	port map (
	--	O => tmp(7), -- LUT general output
	--	I0 => tmp(6),-- LUT input
	--	I1 => sel(0),-- LUT input
	--	I2 => sel(1),
	--	I3 => sel(2)
	--	);
	--	
	--not_8: LUT2
	--	generic map (
	--	INIT => X"8")
	--	port map (
	--	O => tmp(0), -- LUT general output
	--	I0 => tmp(7),-- LUT input
	--	I1 => INIT
	--	);
		
	end Behavioral;
