function [i]=k_means(matrix)%,TNC)
    
    %load(file);
    X = matrix;
    [rows, cols]=size(X);
    
    rng(1); % varying rng might result in different result. 
    C1=mean(X);
    X=reshape(X,rows*cols,1); 
                                                                                                %X_test= X(:,1);
    % Max i is the upper limit of the number of cluster.
    for i=3:16  
	    %figure(i);
	    C=C1(1:i)'; % to use matlab builtin function
        [cidx1,~] = kmeans(X,i,'MaxIter',100,'Start', C, ...
            'EmptyAction','drop'); 
        figure('Visible','off')
        % the average silhouette values for each number of cluster set by 
        % finding the mean of the silhouette values of all the frequencies
        [silh1,~] = silhouette(X,cidx1,'sqeuclidean'); 
        cluster120(i-1)=mean(silh1);                                        %#ok<AGROW> 
    end
%     
%  The ANC has a maximum average silhouette value
    i=find(cluster120==max(cluster120));
    %display(strcat("Number of Cluster: ",num2str(i)));
%##############################################################
% If TNC is provided then, for suspect/recycled FPGA detection, 
% we compare the ANC with a threshold number of clusters (TNC). 

%thres=TNC
%     if i>thres
%         %display('Probable Counterfeit');
%         real=0;
%     else
%         %display('Real')
%         real=1;
%     end
%###############################################################

end






